using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;
namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_RoleFunction
    /// </summary>
    public partial class T_Sys_RoleFunction
    {
        public T_Sys_RoleFunction()
        { }
        #region  Method

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_RoleId", "T_Sys_RoleFunction");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_RoleId, int F_FunctionId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_RoleFunction");
            strSql.Append(" where F_RoleId=@F_RoleId and F_FunctionId=@F_FunctionId ");
            SqlParameter[] parameters = {
					new SqlParameter("@F_RoleId", SqlDbType.Int,4),
					new SqlParameter("@F_FunctionId", SqlDbType.Int,4)			};
            parameters[0].Value = F_RoleId;
            parameters[1].Value = F_FunctionId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(CallCenterApi.Model.T_Sys_RoleFunction model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_RoleFunction(");
            strSql.Append("F_RoleId,F_FunctionId,F_IsKey,F_Short)");
            strSql.Append(" values (");
            strSql.Append("@F_RoleId,@F_FunctionId,@F_IsKey,@F_Short)");
            SqlParameter[] parameters = {
					new SqlParameter("@F_RoleId", SqlDbType.Int,4),
					new SqlParameter("@F_FunctionId", SqlDbType.Int,4),
					new SqlParameter("@F_IsKey", SqlDbType.Int,4),
					new SqlParameter("@F_Short", SqlDbType.Int,4)};
            parameters[0].Value = model.F_RoleId;
            parameters[1].Value = model.F_FunctionId;
            parameters[2].Value = model.F_IsKey;
            parameters[3].Value = model.F_Short;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_RoleFunction model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_RoleFunction set ");
            strSql.Append("F_IsKey=@F_IsKey,");
            strSql.Append("F_Short=@F_Short");
            strSql.Append(" where F_RoleId=@F_RoleId and F_FunctionId=@F_FunctionId ");
            SqlParameter[] parameters = {
					new SqlParameter("@F_IsKey", SqlDbType.Int,4),
					new SqlParameter("@F_Short", SqlDbType.Int,4),
					new SqlParameter("@F_RoleId", SqlDbType.Int,4),
					new SqlParameter("@F_FunctionId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_IsKey;
            parameters[1].Value = model.F_Short;
            parameters[2].Value = model.F_RoleId;
            parameters[3].Value = model.F_FunctionId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_RoleId, int F_FunctionId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_RoleFunction ");
            strSql.Append(" where F_RoleId=@F_RoleId and F_FunctionId=@F_FunctionId ");
            SqlParameter[] parameters = {
					new SqlParameter("@F_RoleId", SqlDbType.Int,4),
					new SqlParameter("@F_FunctionId", SqlDbType.Int,4)			};
            parameters[0].Value = F_RoleId;
            parameters[1].Value = F_FunctionId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_RoleFunction GetModel(int F_RoleId, int F_FunctionId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_RoleId,F_FunctionId,F_IsKey,F_Short from T_Sys_RoleFunction ");
            strSql.Append(" where F_RoleId=@F_RoleId and F_FunctionId=@F_FunctionId ");
            SqlParameter[] parameters = {
					new SqlParameter("@F_RoleId", SqlDbType.Int,4),
					new SqlParameter("@F_FunctionId", SqlDbType.Int,4)			};
            parameters[0].Value = F_RoleId;
            parameters[1].Value = F_FunctionId;

            CallCenterApi.Model.T_Sys_RoleFunction model = new CallCenterApi.Model.T_Sys_RoleFunction();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_RoleId"] != null && ds.Tables[0].Rows[0]["F_RoleId"].ToString() != "")
                {
                    model.F_RoleId = int.Parse(ds.Tables[0].Rows[0]["F_RoleId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_FunctionId"] != null && ds.Tables[0].Rows[0]["F_FunctionId"].ToString() != "")
                {
                    model.F_FunctionId = int.Parse(ds.Tables[0].Rows[0]["F_FunctionId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_IsKey"] != null && ds.Tables[0].Rows[0]["F_IsKey"].ToString() != "")
                {
                    model.F_IsKey = int.Parse(ds.Tables[0].Rows[0]["F_IsKey"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Short"] != null && ds.Tables[0].Rows[0]["F_Short"].ToString() != "")
                {
                    model.F_Short = int.Parse(ds.Tables[0].Rows[0]["F_Short"].ToString());
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_RoleId,F_FunctionId,F_IsKey,F_Short ");
            strSql.Append(" FROM T_Sys_RoleFunction ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_RoleId,F_FunctionId,F_IsKey,F_Short ");
            strSql.Append(" FROM T_Sys_RoleFunction ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_RoleFunction ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_FunctionId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_RoleFunction T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_Sys_RoleFunction";
            parameters[1].Value = "F_FunctionId";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}

